union {  // sword
  union { // blade including tip
    difference { // the blade
      box { <-1 -0.2 -1> <0 0.2 1> }
      cylinder { <0 2.5 -1> <0 2.5 1> 2.5
        translate <0 0.15 0>
        rotatex -20
      }
      cylinder { <0 2.5 -1> <0 2.5 1> 2.5
        translate <0 0.15 0>
        rotatex -20
        scale <1 -1 1>
      }
      cylinder { <0 2.5 -1> <0 2.5 1> 2.5
        translate <0 0.15 0>
        rotatex -20
        scale <1 -1 -1>
      }
      cylinder { <0 2.5 -1> <0 2.5 1> 2.5
        translate <0 0.15 0>
        rotatex -20
        scale <1 1 -1>
      }
      translate <0.5 0 0>
      scale <15 1 1>  // length of blade
    }
    intersection { // the round tip of the blade
      cone { <0 0 0> 0.4385706 <0 0.159 0> 0 }
      cone { <0 0 0> 0.4385706 <0 -0.159 0> 0 }
      slab {<0 -0.159 0> <0 0.159 0>}
      slab {<0 0 0> <1 0 0>}
      scale <3 1 1>
      translate <7.5 0 0>  // half length of blade
    }
    scale <1 0.7 1>

    material {
      pigment <0.85 0.85 0.85>
      ambient 0.2
      diffuse 0.5
      reflection 0.5
      highlight 0.75
      roughness 0.1
    } 
  }
  union { // grip
    union { // hand protection
      box { <-0.8 -0.3 -0.5> <0 0.3 0.5> } // basic plate
      intersection { // sharpened pikes
        union { // pikes
          intersection { // right pikes
            union {
              difference { // forward
                cylinder { <0 -0.3 0> <0 0.3 0> 2 }
                cylinder { <0.5 -0.5 0> <0.5 0.5 0> 1.7 }
                translate <1.2 0 -0.5>
              }
              difference { // backward
                cylinder { <0 -0.3 0> <0 0.3 0> 3 }
                cylinder { <-4.8 -0.5 0> <-4.8 0.5 0> 7 }
                translate <-3 0 -0.5>
              }
            }
            slab {<0 0 -0.5> <0 0 -7.5>}
          }
          intersection { // left pikes
            union {
              difference { // forward
                cylinder { <0 -0.3 0> <0 0.3 0> 2 }
                cylinder { <0.5 -0.5 0> <0.5 0.5 0> 1.7 }
                translate <1.2 0 -0.5>
              }
              difference { // backward
                cylinder { <0 -0.3 0> <0 0.3 0> 3 }
                cylinder { <-4.8 -0.5 0> <-4.8 0.5 0> 7 }
                translate <-3 0 -0.5>
              }
            }
            slab {<0 0 -0.5> <0 0 -7.5>}
            scale <1 1 -1>
          }
        }
        union {
          intersection {
            cylinder { <1.3 -2.2 -4> <1.3 -2.2 4> 2.5 }
            cylinder { <1.3 2.2 -4> <1.3 2.2 4> 2.5 }
            slab {<0 0 0> <20 0 0>
              translate <-0.21 0 0>
              rotatey 22.5
            }
            slab {<0 0 0> <20 0 0>
              translate <-0.21 0 0>
              rotatey -22.5
            }
          }
          intersection {
            cylinder { <1.7 -2.2 -4> <1.7 -2.2 4> 2.5 }
            cylinder { <1.7 2.2 -4> <1.7 2.2 4> 2.5 }
            rotatey 135
            slab {<0 0 0> <20 0 0>
              translate <0.21 0 0>
              rotatey 157.5
            }
            slab {<0 0 0> <20 0 0>
              rotatey 90
            }
          }
          intersection {
            cylinder { <1.7 -2.2 -4> <1.7 -2.2 4> 2.5 }
            cylinder { <1.7 2.2 -4> <1.7 2.2 4> 2.5 }
            rotatey -135
            slab {<0 0 0> <20 0 0>
              translate <0.21 0 0>
              rotatey -157.5
            }
            slab {<0 0 0> <20 0 0>
              rotatey -90
            }
          }
          intersection {
            slab {<0 -0.3002 0> <0 0.3002 0>}
            slab {<1.3 0 0> <-20 0 0>}
            slab {<1.7 0 0> <-20 0 0>
              rotatey 135
            }
            slab {<1.7 0 0> <-20 0 0>
              rotatey -135
            }
          }
        }
      }
      material {
        pigment <0.9 0.6 0.3>
        ambient 0.1
        diffuse 0.6
        reflection 0.5
        highlight 0.7
        roughness 0.1
      }
    }
    union { // handle
      intersection { // small shield plate
        cylinder { <-1 0 0> <-0.8 0 0> 1 }
        slab { <-1 0 0> <-0.8 0 0> }
        scale <1 0.8 1.2>
        material {
          pigment <0.9 0.9 0.9>
          ambient 0.2
          diffuse 0.5
          reflection 0.5
          highlight 0.75
          roughness 0.1
        }
      }
      union {
        sphere {<0 0 0> 1
          scale <0.3 0.55 0.75>
          translate <-1 0 0>
        }
        sphere {<0 0 0> 1
          scale <0.3 0.55 0.75>
          translate <-1.3 0 0>
        }
        sphere {<0 0 0> 1
          scale <0.3 0.55 0.75>
          translate <-1.6 0 0>
        }
        sphere {<0 0 0> 1
          scale <0.3 0.55 0.75>
          translate <-1.9 0 0>
        }
        sphere {<0 0 0> 1
          scale <0.3 0.55 0.75>
           translate <-2.2 0 0>
        }
        sphere {<0 0 0> 1
          scale <0.3 0.55 0.75>
          translate <-2.5 0 0>
        }
        sphere {<0 0 0> 1
          scale <0.3 0.55 0.75>
          translate <-2.8 0 0>
        }
        sphere {<0 0 0> 1
          scale <0.3 0.55 0.75>
          translate <-3.1 0 0>
        }
        sphere {<0 0 0> 1
          scale <0.3 0.55 0.75>
          translate <-3.4 0 0>
        }
        sphere {<0 0 0> 1
          scale <0.3 0.55 0.75>
          translate <-3.7 0 0>
        }
        union { // end knob
          intersection {
            sphere { <0 0 0>  1 // end plate
               scale <0.25 0.8 1>
            }
            slab {<0 0 0> <1 0 0>}
            translate <-4 0 0>
          }
          intersection {
            sphere { <0 0 0>  1 // end sphere
              scale <0.8 0.8 1>
            }
            slab {<-1 0 0> <0 0 0>}
            translate <-4 0 0>
          }
          material {
            pigment   <0.9 0.7 0.2>
            ambient    0.2
            diffuse    0.7
            reflection 0.25
            highlight  0.75
            roughness  0.1
	  }
        }
        translate <0.8 0 0> // to origin
        scale <0.8 0.8 0.8>
        translate <-0.95 0 0> // back

        material {
          pigment  <0.3 0.25 0.2>
          ambient   0.5
          diffuse   0.5
          highlight 0.5
          roughness 0.5
        }
      }
    }
    translate <-7.5 0 0>  // half length
  }
  material {
    pigment  <0.8 0.8 0.8>
    ambient   0.2
    diffuse   0.8
    highlight 0.7
    roughness 0.1

  }
  
  //translate <1 0.64 0>
  scale <0.17 0.17 0.17>
  /*
  translate <0.25 0 0>

  rotate <84 0 35>

  translate <0 0.05 0>
  */
}
